Subject: bug#64202: bug#66188: 29.1; Include Atom feed reader

From: James Thomas <[email-masked]>
Date: Sat, 10 Feb 2024 01:36:21 +0530

Daniel Semyonov wrote:

>>>>>> James Thomas writes:
>
>     > Daniel Semyonov wrote:
>     >>>>>>> James Thomas writes:
>     >>
>     >> > Another thing: The article numbers seem to be assigned in the
>     >> > reverse order of datetime on each fetch: ie. the later posts seem
>     >> > to have a smaller number. Is this intentional?
>     >>
>     >> The articles are numbered based on the order they appear in the feed.
>
>     > Of course, but my point was different. Let me try and explain it better
>     > with an example:
>
> Sorry, but I don't understand this example, you seem to be describing
> the exact opposite of what should be happening.
>
>     > Let's say a fetch in the early morning returns these:
>
>     > 6am : Post 1: article number 3
>     > 7am : Post 2: article number 2
>     > 8am : Post 3: article number 1
>
>     > (note that the order is reverse)
>
> If the 6am post is the first post in the feed, it should get article
> number 1 (and the 8am post should get number 3).
>
>     > And a second fetch later on returns these:
>
>     > 9am : Post 4: article number 6
>     > 10am: Post 5: article number 5
>     > 11am: Post 6: article number 4
>
> Same for the 9am post getting article number 4.
>
>     > When sorting them later on (by number), the order ends up being:
>
>     > 8am : Post 3: article number 1
>     > 7am : Post 2: article number 2
>     > 6am : Post 1: article number 3
>     > 10am: Post 5: article number 5
>     > 11am: Post 6: article number 4
>     > 9am : Post 4: article number 6
>
>     > ...which is neither descending nor ascending (by time). This could be
>     > fixed if the number generation order (on each fetch) were simply
>     > reversed.
>
> If the posts appear in a chronological order, it should end up being
> correct.  I think what's happening is that the feed you're testing
> actually uses a reverse chronological order for posts.  If not, send me
> the feed, I might be misunderstanding something.

Hmm.. It seems to be happening that way for every server I used:

git.savannah.gnu.org/cgit/emacs.git/atom/?h=master

rss.slashdot.org/Slashdot/slashdotMainatom:Slashdot

github.com/emacs-mirror/emacs/commits.atom

(the article numbers are displayed in the Summary buffer modeline)

>
> Also there is no "number generation order", the number is just
> incremented when a new entry is encountered.  You can't know ahead of
> time how many new entries you will encounter, so you can't easily
> "reverse" this process (it is possible though).
>
>     > (info "(gnus) Back End Interface") uses the words 'later' and 'order of
>     > arrival'.
>
>     > WDYT?
>
> I don't think it's really possible to know the order in which entries
> arrived in a feed.  I've seen feeds with posts in chronological,
> reverse-chronological and (seemingly) random orders.  Each entry in each
> feed might contain a date and an "update" date (in Atom feeds).  IME the
> relation between these dates and the dates the corresponding posts were
> actually published or updated is non-existent.
> I still think your best bet is to just sort by date manually.

OK. I think I'll use the datetime; for the time being at least.

Regards,
James